clear
nn=200;%dots per cluster
ss=1000;%complex features
fname='cluster1'
%set parameters
kernelpar=[2 0.05];%for PSVM: RBF kernel with gamma 0.05
psvmpar=[100,0.1];%for PSVM C, epsilon
svmparreg='-s 4 -t 2 -g 0.05 -c 0.07 -n 0.9';%libsvm regression
svmparcl='-s 1 -t 2 -g 0.05 -n 0.80';%libsvm classification

%generate 2dim dataset!!
tt=ones(nn,1);%helper
m1=[1 1];%cluster means
m2=[1 10];
m3=[10 1];
m4=[10 10];
v1=[4 4];%cluster variances
v2=[4 3];
v3=[5 3];
v4=[3 4];
%build dataset of four clusters
X=randn(nn,2).*(tt*v1)+(tt*m1);
Y=-1*ones(nn,1);
X=[X;randn(nn,2).*(tt*v2)+(tt*m2)];
Y=[Y;ones(nn,1)];
X=[X;randn(nn,2).*(tt*v3)+(tt*m3)];
Y=[Y;1*ones(nn,1)];
X=[X;randn(nn,2).*(tt*v4)+(tt*m4)];
Y=[Y;-1*ones(nn,1)];
psave(fname,X,Y);%save dataset for psvm
ssave(fname,X,Y);%save dataset for libsvm
%X(1,1)=-30;%extreme datapoints for optimal plotting
%X(1,2)=-30;
%X(2,1)=30;
%X(2,2)=30;
Z=rand(ss,2)*50-10*ones(ss,2);%equally distributed complex features (not used)
%train with PSVM and libsvm
[pmodel]=psvmtrain(X,Y,kernelpar,psvmpar);
Ytp=psvmpredict(X,pmodel);
[psvm_mse psvm_ce]=psvmcrossval(X,Y,kernelpar,psvmpar,5);%generalizatrion errors
[srmodel]=svmtrain(Y,X,svmparreg);
[scmodel]=svmtrain(Y,X,svmparcl);
Yts=svmpredict(Y,X,scmodel);
[svm_mse_r svm_ce_r]=svmcrossval(X,Y,svmparreg,5);
[svm_mse_c svm_ce_c]=svmcrossval(X,Y,svmparcl,5);

%show classification
XA=[];
XB=[];
for i=1:4*nn
    if(Y(i)>0)
        XA=[XA,X(i,:).'];
    else
        XB=[XB,X(i,:).'];
    end
end
figure(1);
plot(XA(1,:),XA(2,:),'.r',XB(1,:),XB(2,:),'.b')
title('training data');
XA=[];
XB=[];
for i=1:4*nn
    if(Ytp(i)>0)
        XA=[XA,X(i,:).'];
    else
        XB=[XB,X(i,:).'];
    end
end
figure(2);
plot(XA(1,:),XA(2,:),'.r',XB(1,:),XB(2,:),'.b')
title('PSVM predicted data');
XA=[];
XB=[];
for i=1:4*nn
    if(Yts(i)>0)
        XA=[XA,X(i,:).'];
    else
        XB=[XB,X(i,:).'];
    end
end
figure(3);
plot(XA(1,:),XA(2,:),'.r',XB(1,:),XB(2,:),'.b')
title('libSVM predicted data');
%show regression
mmZ=[];
mmX=[-50:49];
mmY=[-50:49];
for i=1:100
    for j=1:100
        mmZ=[mmZ;[i-50,j-50]];
    end
end
YZt=psvmpredict(mmZ,pmodel);
figure(4);
mesh(mmX,mmY,reshape(YZt,100,100));
view(-20,80);
title('PSVM prediction topology');

mmZ=[];
mmX=[-50:49];
mmY=[-50:49];
for i=1:100
    for j=1:100
        mmZ=[mmZ;[i-50,j-50]];
    end
end
YZt=svmpredict(ones(10000,1),mmZ,srmodel);
figure(5);
mesh(mmX,mmY,reshape(YZt,100,100));
view(-20,80);
title('libSVM prediction topology');
%compare generalization errors
'regression cv-error psvm vs. svm'
[psvm_mse svm_mse_r]
'classification cv-error psvm vs. svm'
[psvm_ce svm_ce_c]
%psvmalpha=pmodel{1}%only to show
%libsvmalpha=getfield(smodel,'sv_coef')%only to show
[psvmfeatures,xxx]=size(find(pmodel{1}));%only to show
[svmfeatures_reg,xxx]=size(getfield(srmodel,'sv_coef'));%only to show
[svmfeatures_class,xxx]=size(getfield(scmodel,'sv_coef'));%only to show
psvmfeatures
svmfeatures_reg
svmfeatures_class
