clear
nn=1000;%1000;%entries
dims=10;%%100;%dimensions
fname='cluster2c';%filename
%parameters
kernelpar=[2 0.0001];
psvmpar=[8,0.06];%these are good parameters for generalization
svmpar='-s 3 -t 2 -g 0.0001 -c 1 -p 1';%svm parameters, low influence
%data generation parameters
clusters=3;
means=randn(clusters,dims)*100;
clustervar=100;
%build data matrix
X=[];
Y=[];
Yc=[];
for i=1:nn
    ss=rand(1,1);%cluster selection
    if(ss==1) ss=0; end
    ss=floor(1+ss*clusters);%ss=1..clusters
    noisepos=randn(1,dims)*sqrt(clustervar);%place points randomly around means
    X=[X;means(ss,:)+noisepos];
%    Y=[Y;sum((means(ss,:)-noise)*(means(ss,:)-noise).')];
    Y=[Y;10*noisepos*(noisepos.')/(clustervar*dims)+randn(1,1)*5];%add 50% noise
end
%save data for command line version
psave(fname,X,Y);
ssave(fname,X,Y);

[psvm_mse psvm_ce]=psvmcrossval(X,Y,kernelpar,psvmpar,5);%generalizatrion errors
[svm_mse svm_ce]=svmcrossval(X,Y,svmpar,5);

[pmodel]=psvmtrain(X,Y,kernelpar,psvmpar);
[smodel]=svmtrain(Y,X,svmpar);

[psvmfeatures,xxx]=size(find(pmodel{1}));%only to show
[svmfeatures,xxx]=size(getfield(smodel,'sv_coef'));%only to show
psvm_mse
svm_mse
psvmfeatures
svmfeatures
