clear
nn=30;%30 points in X and Y-direction

%build data matrix
X=[];
YN=[];%labels with noise
Y=[];%labels 
mmX=[-nn/2+1:nn/2];
mmY=[-nn/2+1:nn/2];
nexps=4;%four hills
means=[3 3;-3 -3;3 -3;-4 2];
ints=[3 4 -3 -2];
varc=0.05;%cosine attenuation
vars=ones(1,4)*varc;
freq=[1.3 0.7 1 0.2];
noise=5;
for i=1:nn
    for j=1:nn
        ax=i-nn/2;
        ay=j-nn/2;
        anoise=randn(1,1)*noise;
        X=[X;[ax,ay]];
        yt=0;
        for ii=1:nexps;
            yt=yt+ints(ii)*cos(freq(ii)*sqrt((ax-means(ii,1))^2+(ay-means(ii,2))^2))*exp(-vars(ii)*sqrt((ax-means(ii,1))^2+(ay-means(ii,2))^2));
        end
        Y=[Y;yt];
        YN=[YN;yt+anoise];
    end
end
%build four kernel matrices with different cos frequencies
Z=X;
kpar=[5 1.3 pi/2 varc];%cos kernel, same frequencies as data generation
K1=psvmkernel(X,Z,kpar);
kpar=[5 0.7 pi/2 varc];
K2=psvmkernel(X,Z,kpar);
kpar=[5 1 pi/2 varc];
K3=psvmkernel(X,Z,kpar);
kpar=[5 0.2 pi/2 varc];
K4=psvmkernel(X,Z,kpar);
K=[K1 K2 K3 K4];
%varc=0.2;
%kpar=[5 1.3 pi/2 varc];%cos kernel, same frequencies as data generation
%K1=psvmkernel(X,Z,kpar);
%kpar=[5 0.7 pi/2 varc];
%K2=psvmkernel(X,Z,kpar);
%kpar=[5 1 pi/2 varc];
%K3=psvmkernel(X,Z,kpar);
%kpar=[5 0.2 pi/2 varc];
%K4=psvmkernel(X,Z,kpar);
%K=[K K1 K2 K3 K4];

np=psvmgetnp(K);
KK=psvmputnp(K,np);
psvmpar=[1000,17];%
psvmpar
alpha=psvmsmo(KK,YN,psvmpar);
[ai,aj,av]=find(alpha);
npp=[];
[ai1,ai2]=size(ai);
for i=1:ai1
    npp=[npp,np(:,ai(i))];
end
pkmodel={alpha,mean(YN),npp.'}


%compute models
Ytp=psvmpredict(K,pkmodel);
mserror=(Ytp-Y).'*(Ytp-Y)/(nn*nn)
mserror=(YN-Y).'*(YN-Y)/(nn*nn)
[psvmfeatures,xxx]=size(find(pkmodel{1}));%only to show

figure(1);
mesh(mmX,mmY,reshape(Y,nn,nn));
view(-20,80);
title('data topology');
figure(2);
mesh(mmX,mmY,reshape(YN,nn,nn));
view(-20,80);
title('noised data topology');
%note that the psvm knows the 4 frequencies and the attenuation
figure(3);
mesh(mmX,mmY,reshape(Ytp,nn,nn));
view(-20,80);
title('PSVM prediction topology');

psvmfeatures
