clear
nn=30;%30 points in X and Y-direction
fname='reg'%save data with this name
kernelpar=[2 0.3];
psvmpar=[4,2];

svmpar='-s 3 -t 2 -g 0.3 -c 0.9 -p 1.7';%parameters for noise cancellation

%build data matrix
X=[];
YN=[];%labels with noise
Y=[];%labels 
mmX=[-nn/2+1:nn/2];
mmY=[-nn/2+1:nn/2];
nexps=4;%four hills
means=[3 3;-3 -3;3 -3;-4 2];
ints=[2 3 -2 -1.5];
vars=[3 4 3 5];
noise=1;
for i=1:nn
    for j=1:nn
        ax=i-nn/2;
        ay=j-nn/2;
        anoise=randn(1,1)*noise;
        X=[X;[ax,ay]];
        yt=0;
        for ii=1:nexps;
            yt=yt+ints(ii)*exp(-0.5*((ax-means(ii,1))^2+(ay-means(ii,2))^2)/vars(ii));
        end
        Y=[Y;yt];
        YN=[YN;yt+anoise];
    end
end
psave(fname,X,YN);
ssave(fname,X,YN);
%Z=rand(2,ss)*50-10*ones(2,ss);
%Z=X;

%compute models
[pmodel]=psvmtrain(X,YN,kernelpar,psvmpar);
[smodel]=svmtrain(YN,X,svmpar);
Ytp=psvmpredict(X,pmodel);
Yts=svmpredict(YN,X,smodel);

[psvm_mse psvm_ce]=psvmcrossval(X,YN,kernelpar,psvmpar,5);%generalizatrion errors
[svm_mse svm_ce]=svmcrossval(X,YN,svmpar,5);
[psvmfeatures,xxx]=size(find(pmodel{1}));%only to show
[svmfeatures,xxx]=size(getfield(smodel,'sv_coef'));%only to show

figure(1);
mesh(mmX,mmY,reshape(Y,nn,nn));
view(-20,80);
title('data topology');
v=axis;
figure(2);
mesh(mmX,mmY,reshape(YN,nn,nn));
view(-20,80);
title('noised data topology');
axis(v);

figure(3);
mesh(mmX,mmY,reshape(Ytp,nn,nn));
view(-20,80);
title('PSVM prediction topology');
axis(v);

figure(4);
mesh(mmX,mmY,reshape(Yts,nn,nn));
view(-20,80);
title('SVM prediction topology');
axis(v);

psvm_mse
svm_mse
psvmfeatures
svmfeatures
