function [ee,cee]=psvmcrossvalr(X,Y,ppar,n)
%nfold crossvalidation for relational data without kernel
%ee - mse(regression)
%cee - error (classification)
[La,Na]=size(X);
[X,Y]=shuffle(X,Y);
ss=La/n;
ee=0;
cee=0;
for i=1:n
    if i==1
        Xl=X(floor(ss)+1:end,:);
        Xt=X(1:floor(ss),:);
        Yl=Y(floor(ss)+1:end);
        Yt=Y(1:floor(ss));
    else
        if i==n
            Xl=X(1:floor(ss*(i-1)),:);
            Xt=X(floor(ss*(i-1))+1:end,:);
            Yl=Y(1:floor(ss*(i-1)));
            Yt=Y(floor(ss*(i-1))+1:end);
        else
            Xl=X(1:floor(ss*(i-1)),:);
            Xl=[Xl;X(floor(ss*i)+1:end,:)];
            Xt=X(floor(ss*(i-1))+1:floor(ss*i),:);
            Yl=Y(1:floor(ss*(i-1)));
            Yl=[Yl;Y(floor(ss*i)+1:end)];
            Yt=Y(floor(ss*(i-1))+1:floor(ss*i));
        end
    end
    model=psvmtrain(Xl,Yl,ppar);
    Yp=psvmpredict(Xt,model);
    ee=ee+(Yp-Yt).'*(Yp-Yt);
    tt=sum(sign(Yp.*Yt));
    [tt1,tt2]=size(Yt);
    cee=cee+(tt+tt1)/2;
end
ee=ee/La;
cee=cee/La;
cee=1-cee;

    
    
